## ovito 2.9.0+dfsg1

=== CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2014) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

PROJECT(Ovito)

# Make sure we have a recent version of CMake.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.8.12)

# Choose CMake policies.
CMAKE_POLICY(SET CMP0023 OLD)   # Allow keyword and plain target_link_libraries signatures to be mixed.
CMAKE_POLICY(SET CMP0020 NEW) 	# Automatically link to qtmain.lib on Windows.
IF(NOT CMAKE_VERSION VERSION_LESS "3")
	CMAKE_POLICY(SET CMP0026 OLD)	# Suppress warning when reading the LOCATION target property.
	CMAKE_POLICY(SET CMP0043 OLD)	# Suppress warning because COMPILE_DEFINITIONS_* target property is used.
	CMAKE_POLICY(SET CMP0045 OLD)	# Don't warn about non-existing targets in GET_TARGET_PROPERTY().
ENDIF()

# Check compiler requirement.
IF(CMAKE_CXX_COMPILER_ID STREQUAL MSVC)
	IF(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "18")
		MESSAGE(FATAL_ERROR "OVITO requires Visual C++ 2013 or newer.")
	ENDIF()
ENDIF()

# This is to enable target debugging within Visual Studio Code. 
# It is ignored oustide of Visual Studio Code/CMake tools. 
INCLUDE(CMakeToolsHelpers OPTIONAL)

SET(OVITO_SOURCE_BASE_DIR "${CMAKE_CURRENT_LIST_DIR}")
LIST(APPEND CMAKE_MODULE_PATH ${OVITO_SOURCE_BASE_DIR}/cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/Version.cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/Plugins.cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/PrecompiledHeader.cmake)

# Define build options.
OPTION(OVITO_DOUBLE_PRECISION_FP "Use double-precision floating-point numbers." "OFF")
OPTION(OVITO_BUILD_GUI "Build the graphical user interface." "ON")
OPTION(OVITO_BUILD_APPSTORE_VERSION "Build binaries for the Apple App Store and Windows Store." "OFF")

# Define user options that control the building of OVITO's standard plugins.
OPTION(OVITO_BUILD_PLUGIN_PARTICLES "Build the Particles plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_MESH "Build the Mesh plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_TACHYON "Build the Tachyon renderer plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS "Build the CrystalAnalysis plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_PYSCRIPT "Build the Python scripting plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_NETCDFPLUGIN "Build the NetCDF plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_POVRAY "Build the POV-Ray plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_OPENBABELPLUGIN "Build the OpenBabel plugin (experimental)." "OFF")
OPTION(OVITO_BUILD_PLUGIN_CORRELATION "Build the correlation function plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_VR "Build the virtual reality plugin (experimental)." "OFF")
OPTION(OVITO_BUILD_PLUGIN_VOROTOP "Build the VoroTop plugin." "ON")

# This is a global list of plugin targets that will be built.
# It will get populated by the OVITO_PLUGIN macro.
SET(OVITO_PLUGINS_LIST "")

# Enable software testing framework.
ENABLE_TESTING()

# Activate C++11 language standard.
IF(NOT CMAKE_VERSION VERSION_LESS "3.1")
	SET(CMAKE_CXX_STANDARD 11)
	SET(CMAKE_CXX_STANDARD_REQUIRED ON)
ELSE()
	IF(NOT MSVC)
		IF(CMAKE_COMPILER_IS_GNUCXX)
		    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
		ELSE()
	    	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
		ENDIF()
	ENDIF()
ENDIF()

IF(CYGWIN)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		# Linking fails without -O3
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
	ENDIF()
ENDIF()

IF(APPLE)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++ -Wno-invalid-offsetof")
ENDIF()

IF(MSVC)
	# Suppress warning related to QVarLengthArray implementation.
	ADD_COMPILE_OPTIONS("/wd4996")
	# Suppress warning on conversion from size_t to int, possible loss of data.
	ADD_COMPILE_OPTIONS("/wd4267")
	# Compiling template code leads to large object files.
	ADD_COMPILE_OPTIONS("/bigobj")	
ENDIF()

IF(UNIX)
	IF(APPLE)
		SET(MACOSX_BUNDLE_NAME "Ovito") 
		SET(MACOSX_BUNDLE_BUNDLE_NAME "${MACOSX_BUNDLE_NAME}") 
		
		# The directory where the main executable goes to.
		SET(OVITO_RELATIVE_BINARY_DIRECTORY ".")
		# The directory where the main libraries go to.
		SET(OVITO_RELATIVE_LIBRARY_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/MacOS")
		# The directory where the auxiliary files go to.
		SET(OVITO_RELATIVE_SHARE_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/Resources")
		# The directory where the compiled plugins go to.
		SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/PlugIns")	
		# The directory where the Python source modules go to.
		SET(OVITO_RELATIVE_PYTHON_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/Resources/python")	
	ELSE()
		# The directory where the main executable goes to.
		SET(OVITO_RELATIVE_BINARY_DIRECTORY "bin")
		# The directory where the main libraries go to.
		SET(OVITO_RELATIVE_LIBRARY_DIRECTORY "lib/ovito")
		# The directory where the auxiliary files go to.
		SET(OVITO_RELATIVE_SHARE_DIRECTORY "share/ovito")
		# The directory where the compiled plugins go to.
		SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins")
		# The directory where the Python source modules go to.
		SET(OVITO_RELATIVE_PYTHON_DIRECTORY "${OVITO_RELATIVE_PLUGINS_DIRECTORY}/python")
	ENDIF()
ELSE()
	# The directory where the main executable goes to.
	SET(OVITO_RELATIVE_BINARY_DIRECTORY ".")
	# The directory where the main libraries go to.
	SET(OVITO_RELATIVE_LIBRARY_DIRECTORY ".")
	# The directory where the auxiliary files go to.
	SET(OVITO_RELATIVE_SHARE_DIRECTORY ".")
	# The directory where the compiled plugins go to.
	SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins")
		# The directory where the Python source modules go to.
	SET(OVITO_RELATIVE_PYTHON_DIRECTORY "${OVITO_RELATIVE_PLUGINS_DIRECTORY}/python")	
ENDIF()

# Controls whether a redistributable installation package of OVITO is built.
OPTION(OVITO_REDISTRIBUTABLE_PACKAGE "Create a redistributable program package that includes third-party libraries." "OFF")

IF(APPLE OR WIN32 OR NOT OVITO_REDISTRIBUTABLE_PACKAGE)
	SET(OVITO_DEFAULT_LIBRARY_TYPE SHARED)
    
	# Add the automatically determined parts of the RPATH,
	# which point to directories outside the build tree to the install RPATH
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	    
ELSE()
	SET(OVITO_DEFAULT_LIBRARY_TYPE STATIC)
ENDIF()

# The directory where the main executable goes to.
SET(OVITO_BINARY_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_BINARY_DIRECTORY}")
# The directory where the main libraries go to.
SET(OVITO_LIBRARY_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_LIBRARY_DIRECTORY}")
# The directory where the compiled plugins go to.
SET(OVITO_PLUGINS_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
# The directory where the Python source files go to.
SET(OVITO_PYTHON_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_PYTHON_DIRECTORY}")
# The directory where the auxiliary files go to.
SET(OVITO_SHARE_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_SHARE_DIRECTORY}")

# This is the name suffix used for generating plugin libraries.
SET(OVITO_PLUGIN_LIBRARY_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
IF(APPLE)
	# On Mac OS, we use the .so extension instead of the standard .dylib to be compatible
	# with the Python interpreter, which only finds modules having a .so suffix.
	SET(OVITO_PLUGIN_LIBRARY_SUFFIX ".so")
ENDIF()

# This macro installs a required third-party DLL in the OVITO directory
# so that it can be distributed together with the program.
MACRO(OVITO_INSTALL_DLL dll)
	MESSAGE("Deploying DLL ${dll}.")
	EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" "-E" "copy_if_different" "${dll}" "${OVITO_BINARY_DIRECTORY}" RESULT_VARIABLE error_var)
	IF(error_var)
		MESSAGE(FATAL_ERROR "Failed to copy DLL into build directory: ${dll}")
	ENDIF()
	INSTALL(FILES "${dll}" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")
ENDMACRO()

# This macro installs a required third-party shared library in the OVITO directory
# so that it can be distributed together with the program.
MACRO(OVITO_INSTALL_SHARED_LIB shared_lib destination_dir)
	FILE(MAKE_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${destination_dir}")
	# Strip version number from shared lib filename.
	GET_FILENAME_COMPONENT(shared_lib_ext "${shared_lib}" EXT)
	STRING(REPLACE ${shared_lib_ext} ".so" shared_lib_new "${shared_lib}")
	FILE(GLOB lib_versions "${shared_lib_new}*")
	FOREACH(lib_version ${lib_versions})
		IF(IS_SYMLINK ${lib_version})
			GET_FILENAME_COMPONENT(symlink_target "${lib_version}" REALPATH)
			GET_FILENAME_COMPONENT(symlink_target_name "${symlink_target}" NAME)
			GET_FILENAME_COMPONENT(lib_version_name "${lib_version}" NAME)
			MESSAGE("Installing symlink ${lib_version} to shared library ${symlink_target}")
			EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -E create_symlink ${symlink_target_name} "${${PROJECT_NAME}_BINARY_DIR}/${destination_dir}/${lib_version_name}")
		ELSE()
			MESSAGE("Installing shared library ${lib_version}")
			CONFIGURE_FILE("${lib_version}" "${${PROJECT_NAME}_BINARY_DIR}/${destination_dir}/" COPYONLY)
		ENDIF()
		INSTALL(FILES "${lib_version}" DESTINATION "${destination_dir}/")
	ENDFOREACH()
ENDMACRO()

# Tell CMake to run Qt moc whenever necessary.
SET(CMAKE_AUTOMOC ON)
# As moc files are generated in the binary dir, tell CMake to always look for includes there.
SET(CMAKE_INCLUDE_CURRENT_DIR ON)
  
# Find and set up Qt5 libraries.
FOREACH(component IN ITEMS Core Concurrent Network Gui)
	FIND_PACKAGE(Qt5${component} REQUIRED)
ENDFOREACH()
IF(OVITO_BUILD_GUI) 
	FOREACH(component IN ITEMS Widgets PrintSupport)
		FIND_PACKAGE(Qt5${component} REQUIRED)
	ENDFOREACH()
	IF(UNIX AND NOT APPLE AND CMAKE_COMPILER_IS_GNUCXX)
		# This is an indirect dependency:
		FIND_PACKAGE(Qt5DBus REQUIRED)
	ENDIF()
ENDIF()

# Find the Boost library.
FIND_PACKAGE(Boost REQUIRED)
IF(NOT Boost_FOUND)
	MESSAGE(FATAL_ERROR "The Boost library could not be found on your system. ${Boost_ERROR_REASON}")
ENDIF()

# Generate build targets.
ADD_SUBDIRECTORY(src)

# Gnerate user documentation.
INCLUDE(cmake/Documentation.cmake)

# Set up CPack for generating distributable program packages.
INCLUDE(cmake/Packaging.cmake)

# Export our targets so that external plugins can use them.
CONFIGURE_FILE(cmake/OVITOConfig.cmake "${${PROJECT_NAME}_BINARY_DIR}/" @ONLY)
IF(NOT CMAKE_VERSION VERSION_LESS "3")
	EXPORT(EXPORT OVITO NAMESPACE "Ovito::" FILE OVITOTargets.cmake)
ENDIF()

=== src/3rdparty/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2014) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

ADD_SUBDIRECTORY(botan)
ADD_SUBDIRECTORY(qssh)
IF(OVITO_BUILD_GUI)
    ADD_SUBDIRECTORY(qwt)
ENDIF()
IF(OVITO_BUILD_PLUGIN_PARTICLES)
    ADD_SUBDIRECTORY(muparser)
    ADD_SUBDIRECTORY(voro++)
    ADD_SUBDIRECTORY(ptm)
    ADD_SUBDIRECTORY(copr)
ENDIF()
IF(OVITO_BUILD_PLUGIN_TACHYON)
	ADD_SUBDIRECTORY(tachyon)
ENDIF()
IF(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS)
	ADD_SUBDIRECTORY(geogram)
ENDIF()

=== src/core/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Find Libav libraries for video encoding support.
FIND_PACKAGE(Libav)

# Find the zlib library. It is required for reading/writing compressed data files.
FIND_PACKAGE(ZLIB REQUIRED)

SET(SourceFiles 
	utilities/Exception.cpp
	utilities/linalg/AffineDecomposition.cpp
	utilities/io/SaveStream.cpp
	utilities/io/LoadStream.cpp
	utilities/io/gzdevice/qtiocompressor.cpp
	object/OvitoObject.cpp
	object/OvitoObjectType.cpp
	object/NativeOvitoObjectType.cpp
	plugins/Plugin.cpp
	plugins/PluginManager.cpp
	plugins/autostart/AutoStartObject.cpp
	app/Application.cpp
	app/StandaloneApplication.cpp
	reference/CloneHelper.cpp
	reference/PropertyFieldDescriptor.cpp
	reference/PropertyField.cpp
	reference/RefMaker.cpp
	reference/RefTarget.cpp
	reference/RefTargetListener.cpp
	animation/AnimationSettings.cpp
	animation/controller/Controller.cpp
	animation/controller/ConstantControllers.cpp
	animation/controller/KeyframeController.cpp
	animation/controller/LinearInterpolationControllers.cpp
	animation/controller/SplineInterpolationControllers.cpp
	animation/controller/TCBInterpolationControllers.cpp
	animation/controller/AnimationKeys.cpp
	animation/controller/LookAtController.cpp
	animation/controller/PRSTransformationController.cpp
	dataset/DataSet.cpp
	dataset/DataSetContainer.cpp
	dataset/UndoStack.cpp
	dataset/importexport/FileImporter.cpp
	dataset/importexport/FileExporter.cpp
	dataset/importexport/FileSourceImporter.cpp
	dataset/importexport/FileSource.cpp
	dataset/importexport/AttributeFileExporter.cpp
	scene/SceneNode.cpp
	scene/ObjectNode.cpp
	scene/SceneRoot.cpp
	scene/SelectionSet.cpp
	scene/objects/DisplayObject.cpp
	scene/objects/AsynchronousDisplayObject.cpp
	scene/objects/DataObject.cpp
	scene/objects/CompoundObject.cpp
	scene/objects/geometry/TriMeshObject.cpp
	scene/objects/geometry/TriMeshDisplay.cpp
	scene/objects/camera/CameraObject.cpp
	scene/objects/helpers/TargetObject.cpp
	scene/pipeline/PipelineFlowState.cpp
	scene/pipeline/PipelineObject.cpp
	scene/pipeline/Modifier.cpp
	scene/pipeline/ModifierApplication.cpp
	scene/pipeline/AsyncPipelineEvaluationHelper
	utilities/units/UnitsManager.cpp
	utilities/io/ObjectSaveStream.cpp
	utilities/io/ObjectLoadStream.cpp
	utilities/io/FileManager.cpp
	utilities/io/SftpJob.cpp
	utilities/io/CompressedTextReader.cpp
	utilities/io/CompressedTextWriter.cpp
	utilities/concurrent/PromiseWatcher.cpp
	utilities/concurrent/Promise.cpp
	utilities/concurrent/TaskManager.cpp
	utilities/concurrent/Task.cpp
	utilities/mesh/TriMesh.cpp
	rendering/SceneRenderer.cpp
	rendering/noninteractive/NonInteractiveSceneRenderer.cpp
	rendering/noninteractive/DefaultLinePrimitive.cpp
	rendering/noninteractive/DefaultParticlePrimitive.cpp
	rendering/noninteractive/DefaultTextPrimitive.cpp
	rendering/noninteractive/DefaultImagePrimitive.cpp
	rendering/noninteractive/DefaultArrowPrimitive.cpp
	rendering/noninteractive/DefaultMeshPrimitive.cpp
	rendering/noninteractive/DefaultMarkerPrimitive.cpp
	rendering/RenderSettings.cpp
	rendering/FrameBuffer.cpp
	viewport/Viewport.cpp
	viewport/ViewportConfiguration.cpp
	viewport/ViewportSettings.cpp
	viewport/overlay/ViewportOverlay.cpp
	viewport/overlay/CoordinateTripodOverlay.cpp
	viewport/overlay/TextLabelOverlay.cpp
)

# Include video encoder interface code.
IF(LIBAV_FOUND)
	LIST(APPEND SourceFiles utilities/io/video/VideoEncoder.cpp)
ELSE()
	MESSAGE("LibAV video encoding library not found. Will build OVITO without video support.")
ENDIF()

# Compile resources.
QT5_ADD_RESOURCES(ResourceFiles resources/core.qrc)

# Build library
ADD_LIBRARY(Core SHARED Core.cpp ${SourceFiles} ${ResourceFiles})

# Pass name of core plugin to the code.
TARGET_COMPILE_DEFINITIONS(Core PRIVATE "OVITO_PLUGIN_NAME=\"Core\"")

# Set default include directory.
TARGET_INCLUDE_DIRECTORIES(Core PUBLIC "$<BUILD_INTERFACE:${OVITO_SOURCE_BASE_DIR}/src>")

# Required by built-in SSH client.
TARGET_LINK_LIBRARIES(Core PRIVATE QSsh)

# Link to zlib library.
TARGET_LINK_LIBRARIES(Core PRIVATE ${ZLIB_LIBRARIES})
TARGET_INCLUDE_DIRECTORIES(Core PRIVATE "${ZLIB_INCLUDE_DIRS}")

# Add Boost include directories.
TARGET_INCLUDE_DIRECTORIES(Core PUBLIC ${Boost_INCLUDE_DIRS})

# Link to Qt5.
TARGET_LINK_LIBRARIES(Core PUBLIC Qt5::Core Qt5::Gui Qt5::Concurrent)
TARGET_LINK_LIBRARIES(Core PRIVATE Qt5::Network)

# Link to video encoding lib.
IF(LIBAV_FOUND)
	TARGET_COMPILE_DEFINITIONS(Core PUBLIC OVITO_VIDEO_OUTPUT_SUPPORT)
	TARGET_LINK_LIBRARIES(Core PRIVATE ${Libav_LIBRARIES})
	TARGET_INCLUDE_DIRECTORIES(Core BEFORE PRIVATE ${Libav_INCLUDE_DIRS})
ENDIF()

# Define the OVITO_DEBUG macro in debug builds.
TARGET_COMPILE_DEFINITIONS(Core PUBLIC "$<$<CONFIG:Debug>:OVITO_DEBUG>")

# Floating point precision control.
IF(NOT OVITO_DOUBLE_PRECISION_FP)
    TARGET_COMPILE_DEFINITIONS(Core PUBLIC "FLOATTYPE_FLOAT")
ENDIF()

IF(OVITO_BUILD_APPSTORE_VERSION)
    TARGET_COMPILE_DEFINITIONS(Core PUBLIC "OVITO_BUILD_APPSTORE_VERSION")
ENDIF()

# Pass version information to source code.
SET_SOURCE_FILES_PROPERTIES(app/Application.cpp app/StandaloneApplication.cpp PROPERTIES COMPILE_DEFINITIONS 
    "OVITO_VERSION_MAJOR=${OVITO_VERSION_MAJOR};OVITO_VERSION_MINOR=${OVITO_VERSION_MINOR};OVITO_VERSION_REVISION=${OVITO_VERSION_REVISION};OVITO_VERSION_STRING=\"${OVITO_VERSION_STRING}\"")
SET_SOURCE_FILES_PROPERTIES(utilities/io/SaveStream.cpp utilities/io/LoadStream.cpp PROPERTIES COMPILE_DEFINITIONS 
    "OVITO_FILE_FORMAT_VERSION=${OVITO_FILE_FORMAT_VERSION}")

# Speed up compilation by using precompiled headers.
ADD_PRECOMPILED_HEADER(Core core/Core.h)

IF(APPLE)
    # Activate @rpath on MacOS.
    SET_TARGET_PROPERTIES(Core PROPERTIES MACOSX_RPATH TRUE)
	# This is required to avoid error by install_name_tool on MacOS.
	SET_TARGET_PROPERTIES(Core PROPERTIES LINK_FLAGS "-headerpad_max_install_names")
ELSEIF(UNIX)
    SET_TARGET_PROPERTIES(Core PROPERTIES INSTALL_RPATH "$ORIGIN")
ENDIF()
    
# This library is part of the installation package.
INSTALL(TARGETS Core EXPORT OVITO
	RUNTIME DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}"
	LIBRARY DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")

# Export target to make it accessible for external plugins.
IF(CMAKE_VERSION VERSION_LESS "3")
	EXPORT(TARGETS Core NAMESPACE "Ovito::" APPEND FILE "${${PROJECT_NAME}_BINARY_DIR}/OVITOTargets.cmake")
ENDIF()

# Install Libav video encoding libraries.
IF(LIBAV_FOUND)	
	FOREACH(lib ${Libav_LIBRARIES})
		GET_FILENAME_COMPONENT(base_name "${lib}" NAME_WE)
		GET_FILENAME_COMPONENT(lib_path "${lib}" PATH)
		IF(WIN32)
			FILE(GLOB lib_dll "${lib_path}/${base_name}-*.dll")
			IF(NOT lib_dll)
				MESSAGE(FATAL_ERROR "Could not find corresponding DLL for Libav library '${lib}' in same directory.")
			ENDIF()
			FOREACH(dll ${lib_dll})
				OVITO_INSTALL_DLL("${dll}")
			ENDFOREACH()
		ELSEIF(UNIX AND NOT APPLE AND OVITO_REDISTRIBUTABLE_PACKAGE)
			FILE(GLOB lib_versions "${lib}*")
			FOREACH(lib_version ${lib_versions})
				INSTALL(FILES "${lib_version}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")
			ENDFOREACH()
		ENDIF()
	ENDFOREACH()
ENDIF()

# Install the zlib DLL.
IF(WIN32)
	LIST(GET ZLIB_LIBRARIES 0 ZLIB_FIRST_LIBRARY)
	GET_FILENAME_COMPONENT(ZLIB_LIBRARY_PATH "${ZLIB_FIRST_LIBRARY}" PATH)
	OVITO_INSTALL_DLL("${ZLIB_LIBRARY_PATH}/../bin/zlib.dll")
ENDIF()

=== src/gui/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2016) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

SET(SourceFiles 
	mainwin/MainWindow.cpp
	mainwin/ViewportsPanel.cpp
	mainwin/TaskDisplayWidget.cpp
	mainwin/cmdpanel/CommandPanel.cpp
	mainwin/cmdpanel/RenderCommandPage.cpp
	mainwin/cmdpanel/ModifyCommandPage.cpp
	mainwin/cmdpanel/ModificationListModel.cpp
	mainwin/cmdpanel/ModificationListItem.cpp
	mainwin/cmdpanel/ModifierListBox.cpp
	mainwin/cmdpanel/UtilityCommandPage.cpp
	mainwin/cmdpanel/OverlayCommandPage.cpp
	dialogs/AdjustCameraDialog.cpp
	dialogs/AnimationKeyEditorDialog.cpp
	dialogs/AnimationSettingsDialog.cpp
	dialogs/ApplicationSettingsDialog.cpp
	dialogs/GeneralSettingsPage.cpp
	dialogs/ViewportSettingsPage.cpp
	dialogs/HistoryFileDialog.cpp
	dialogs/ImportFileDialog.cpp
	dialogs/ImportRemoteFileDialog.cpp
	dialogs/SaveImageFileDialog.cpp
	dialogs/LoadImageFileDialog.cpp
	dialogs/RemoteAuthenticationDialog.cpp
	dialogs/FileExporterSettingsDialog.cpp
	actions/ActionManager.cpp
	actions/FileActions.cpp
	actions/ViewportActions.cpp
	actions/AnimationActions.cpp
	actions/RenderActions.cpp
	actions/ViewportModeAction.cpp
	dataset/importexport/FileSourceEditor.cpp
	dataset/importexport/FileImporterEditor.cpp
	dataset/importexport/AttributeFileExporterEditor.cpp
	dataset/GuiDataSetContainer.cpp
	widgets/general/RolloutContainer.cpp
	widgets/general/SpinnerWidget.cpp
	widgets/general/ColorPickerWidget.cpp
	widgets/general/ElidedTextLabel.cpp
	widgets/general/AutocompleteLineEdit.cpp
	widgets/general/AutocompleteTextEdit.cpp
	widgets/general/HtmlListWidget.cpp
	widgets/animation/AnimationTimeSpinner.cpp
	widgets/animation/AnimationFramesToolButton.cpp
	widgets/animation/AnimationTimeSlider.cpp
	widgets/animation/AnimationTrackBar.cpp
	widgets/rendering/FrameBufferWidget.cpp
	widgets/rendering/FrameBufferWindow.cpp
	widgets/selection/SceneNodesListModel.cpp
	widgets/selection/SceneNodeSelectionBox.cpp
	widgets/display/CoordinateDisplayWidget.cpp
	widgets/display/StatusWidget.cpp
	plugins/utility/UtilityApplet.cpp
	plugins/autostart/GuiAutoStartObject.cpp
	properties/PropertiesEditor.cpp
	properties/PropertiesPanel.cpp
	properties/ParameterUI.cpp
	properties/NumericalParameterUI.cpp
	properties/AffineTransformationParameterUI.cpp
	properties/BooleanActionParameterUI.cpp
	properties/BooleanGroupBoxParameterUI.cpp
	properties/BooleanParameterUI.cpp
	properties/BooleanRadioButtonParameterUI.cpp
	properties/ColorParameterUI.cpp
	properties/CustomParameterUI.cpp
	properties/FilenameParameterUI.cpp
	properties/FloatParameterUI.cpp
	properties/FontParameterUI.cpp
	properties/IntegerParameterUI.cpp
	properties/IntegerRadioButtonParameterUI.cpp
	properties/RefTargetListParameterUI.cpp
	properties/StringParameterUI.cpp
	properties/SubObjectParameterUI.cpp
	properties/VariantComboBoxParameterUI.cpp
	properties/Vector3ParameterUI.cpp
	rendering/ViewportSceneRenderer.cpp
	rendering/RenderSettingsEditor.cpp
	viewport/ViewportWindow.cpp
	viewport/ViewportMenu.cpp
	viewport/input/ViewportInputManager.cpp
	viewport/input/ViewportInputMode.cpp
	viewport/input/NavigationModes.cpp
	viewport/input/XFormModes.cpp
	viewport/picking/PickingSceneRenderer.cpp
	viewport/overlay/CoordinateTripodOverlayEditor.cpp
	viewport/overlay/TextLabelOverlayEditor.cpp
	viewport/overlay/MoveOverlayInputMode.cpp
	app/GuiApplication.cpp
	scene/objects/camera/CameraObjectEditor.cpp
	scene/objects/geometry/TriMeshDisplayEditor.cpp
	utilities/io/GuiFileManager.cpp
	utilities/concurrent/ProgressDialog.cpp
	animation/controller/TCBInterpolationControllerEditor.cpp
)

# Compile resources.
QT5_ADD_RESOURCES(ResourceFiles resources/gui.qrc)

# Build library
ADD_LIBRARY(Gui SHARED GUI.cpp ${SourceFiles} ${ResourceFiles})

# Pass name of gui plugin to the code.
TARGET_COMPILE_DEFINITIONS(Gui PRIVATE "OVITO_PLUGIN_NAME=\"Gui\"")

# Set default include directory.
TARGET_INCLUDE_DIRECTORIES(Gui PUBLIC "$<BUILD_INTERFACE:${OVITO_SOURCE_BASE_DIR}/src>")

# GUI is based on Core and the OpenGL rendering library.
TARGET_LINK_LIBRARIES(Gui PUBLIC Core OpenGLRenderer)

# Link Qt5.
TARGET_LINK_LIBRARIES(Gui PUBLIC Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Network)

# Speed up compilation by using precompiled headers.
ADD_PRECOMPILED_HEADER(Gui gui/GUI.h)

IF(APPLE)
    # Activate @rpath on MacOS.
    SET_TARGET_PROPERTIES(Gui PROPERTIES MACOSX_RPATH TRUE)
	# This is required to avoid error by install_name_tool on MacOS.
	SET_TARGET_PROPERTIES(Gui PROPERTIES LINK_FLAGS "-headerpad_max_install_names")
ELSEIF(UNIX)
    SET_TARGET_PROPERTIES(Gui PROPERTIES INSTALL_RPATH "$ORIGIN")
ENDIF()
    
# This library is part of the installation package.
INSTALL(TARGETS Gui EXPORT OVITO
	RUNTIME DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}"
	LIBRARY DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")

# Export target to make it accessible for external plugins.
IF(CMAKE_VERSION VERSION_LESS "3")
	EXPORT(TARGETS Gui NAMESPACE "Ovito::" APPEND FILE "${${PROJECT_NAME}_BINARY_DIR}/OVITOTargets.cmake")
ENDIF()

=== src/main/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Include the resource in the Win32 executable.
IF(WIN32)
	SET(WINDOWS_RESOURCES resources/ovito.rc)
ENDIF(WIN32)

IF(CMAKE_BUILD_TYPE STREQUAL "Release")
	# This will create a GUI application on Windows platform.
	SET(OVITO_WIN32_EXECUTABLE "WIN32")
ELSE()
	# This will create a console application on Windows platform.
	SET(OVITO_WIN32_EXECUTABLE "")
ENDIF()

# Builds the main executable of the application
ADD_EXECUTABLE(${PROJECT_NAME} ${OVITO_WIN32_EXECUTABLE} MACOSX_BUNDLE Main.cpp ${WINDOWS_RESOURCES})

# The executable depends on the core and the gui modules, of course.
TARGET_LINK_LIBRARIES(${PROJECT_NAME} Core Gui)

# Put the executable into the right directory.
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${OVITO_BINARY_DIRECTORY}")

# Set name of executable.
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "ovito")

# Link Qt5.
TARGET_LINK_LIBRARIES(${PROJECT_NAME} Qt5::Core Qt5::Gui)

IF(APPLE)
    # Enable the use of @rpath on OSX.
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES MACOSX_RPATH TRUE)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES INSTALL_RPATH "@executable_path/")
ELSEIF(UNIX)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES INSTALL_RPATH "$ORIGIN/../lib/ovito/")
ENDIF()

# This executable will be part of the installation package.
INSTALL(TARGETS ${PROJECT_NAME} DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/")

# Build all plugins first before building the main executable.
FOREACH(plugin ${OVITO_PLUGIN_LIST})
    ADD_DEPENDENCIES(${PROJECT_NAME} ${plugin})
ENDFOREACH()

# Install fonts required by 'minimal' platform plugin on Linux
IF(UNIX AND NOT APPLE)
    INSTALL(DIRECTORY "resources/fonts" DESTINATION "${OVITO_RELATIVE_SHARE_DIRECTORY}/")
ENDIF()

IF(UNIX AND NOT APPLE AND OVITO_REDISTRIBUTABLE_PACKAGE)
	# Install copies of the Qt libraries.
	FOREACH(component IN ITEMS Core Gui Widgets Concurrent Network PrintSupport)
		GET_TARGET_PROPERTY(lib Qt5::${component} LOCATION)
		GET_TARGET_PROPERTY(lib_soname Qt5::${component} IMPORTED_SONAME_RELEASE)
		CONFIGURE_FILE("${lib}" "${OVITO_LIBRARY_DIRECTORY}" COPYONLY)		
		GET_FILENAME_COMPONENT(lib_realname "${lib}" NAME)
		EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -E create_symlink ${lib_realname} "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/${lib_soname}")
		INSTALL(FILES "${lib}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")
		INSTALL(FILES "${OVITO_LIBRARY_DIRECTORY}/${lib_soname}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")
		GET_FILENAME_COMPONENT(QtBinaryPath ${lib} PATH)
	ENDFOREACH()

	# Create a qt.conf file.
	# This is required to let Qt search for its plugin modules in the program directory.
	INSTALL(CODE "
	    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_BINARY_DIRECTORY}/qt.conf\" \"[Paths]\\nPlugins = ../${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/\")
	    " COMPONENT Runtime)

	# Install Qt plugins.
	INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/platforms" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/")
	INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/bearer" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/")
	INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/imageformats" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/" PATTERN "libqsvg.so" EXCLUDE)
	IF(NOT Qt5Core_VERSION VERSION_LESS "5.6")
		INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/xcbglintegrations" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/")
		OVITO_INSTALL_SHARED_LIB("${QtBinaryPath}/libQt5DBus.so" "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/lib")
		OVITO_INSTALL_SHARED_LIB("${QtBinaryPath}/libQt5XcbQpa.so" "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/lib")
	ENDIF()

	# Make the executable look in lib/ovito/ directory for shared libraries.
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES INSTALL_RPATH "\$ORIGIN/../lib/ovito")
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES BUILD_WITH_INSTALL_RPATH "1")

	# Update: No longer bundle libstdc++.so.6 with OVITO, because it causes conflicts with the OpenGL driver on
	# some systems.
	#FIND_LIBRARY(OVITO_LIBSTDCXX NAMES libstdc++.so.6 PATHS /usr/lib /usr/lib/x86_64-linux-gnu NO_DEFAULT_PATH)
	#IF(NOT OVITO_LIBSTDCXX)
	#	MESSAGE(FATAL_ERROR "Please specify the location of the C++ standard library with the OVITO_LIBSTDCXX option.") 
	#ENDIF()
	#GET_FILENAME_COMPONENT(OVITO_LIBSTDCXX_REAL ${OVITO_LIBSTDCXX} REALPATH)
	#INSTALL(FILES "${OVITO_LIBSTDCXX}" "${OVITO_LIBSTDCXX_REAL}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")

ENDIF()

# On Windows, the third-party library DLLs need to be installed in the OVITO directory.
IF(WIN32)
	# Gather Qt dynamic link libraries.
	FOREACH(component IN ITEMS Core Gui Widgets Concurrent Network PrintSupport)
		GET_TARGET_PROPERTY(dll Qt5::${component} LOCATION_${CMAKE_BUILD_TYPE})
		OVITO_INSTALL_DLL("${dll}")
		IF(${component} MATCHES "Core")
			GET_FILENAME_COMPONENT(QtBinaryPath ${dll} PATH)
			IF(Qt5Core_VERSION VERSION_LESS "5.6")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icudt53.dll")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icuin53.dll")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icuuc53.dll")
			ELSEIF(Qt5Core_VERSION VERSION_LESS "5.7")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icudt54.dll")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icuin54.dll")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icuuc54.dll")
			ENDIF()
		ENDIF()
	ENDFOREACH()
	
	# Install Qt plugins.
	IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
		INSTALL(FILES "${QtBinaryPath}/../plugins/platforms/qwindowsd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/platforms/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qjpegd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qgifd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
	ELSE()
		INSTALL(FILES "${QtBinaryPath}/../plugins/platforms/qwindows.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/platforms/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qjpeg.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qgif.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
	ENDIF()
	
	# Create a qt.conf file.
	# This is required to let Qt search for its plugin modules in the program directory.
	INSTALL(CODE "
	    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_BINARY_DIRECTORY}/qt.conf\" \"[Paths]\\nPlugins = plugins/\")
	    " COMPONENT Runtime)

ENDIF()

# Fix Mac app bundle.
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/FixupMacBundle.cmake)

=== src/opengl_renderer/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2016) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Find OpenGL library.
FIND_PACKAGE(OpenGL REQUIRED)
ADD_LIBRARY(OpenGLLib SHARED IMPORTED GLOBAL)
SET_PROPERTY(TARGET OpenGLLib PROPERTY IMPORTED_LOCATION "${OPENGL_gl_LIBRARY}")
SET_PROPERTY(TARGET OpenGLLib APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${OPENGL_INCLUDE_DIR}")

SET(SourceFiles 
	OpenGLLinePrimitive.cpp
	OpenGLParticlePrimitive.cpp
	OpenGLTextPrimitive.cpp
	OpenGLImagePrimitive.cpp
	OpenGLArrowPrimitive.cpp
	OpenGLMeshPrimitive.cpp
	OpenGLMarkerPrimitive.cpp
	OpenGLSharedResource.cpp
	OpenGLSceneRenderer.cpp
	StandardSceneRenderer.cpp
)

# Compile resources.
QT5_ADD_RESOURCES(ResourceFiles resources/resources.qrc)

# Build library
ADD_LIBRARY(OpenGLRenderer SHARED ${SourceFiles} ${ResourceFiles})

# Pass name of gui plugin to the code. 
TARGET_COMPILE_DEFINITIONS(OpenGLRenderer PRIVATE "OVITO_PLUGIN_NAME=\"OpenGLRenderer\"")

# Set default include directory.
TARGET_INCLUDE_DIRECTORIES(OpenGLRenderer PUBLIC "$<BUILD_INTERFACE:${OVITO_SOURCE_BASE_DIR}/src>")

# Library is based on Core.
TARGET_LINK_LIBRARIES(OpenGLRenderer PUBLIC Core)

# Link to OpenGL library.
TARGET_LINK_LIBRARIES(OpenGLRenderer PRIVATE ${OPENGL_gl_LIBRARY})

# Link Qt5.
TARGET_LINK_LIBRARIES(OpenGLRenderer PUBLIC Qt5::Core Qt5::Gui)

IF(APPLE)
    # Activate @rpath on MacOS.
    SET_TARGET_PROPERTIES(OpenGLRenderer PROPERTIES MACOSX_RPATH TRUE)
	# This is required to avoid error by install_name_tool on MacOS.
	SET_TARGET_PROPERTIES(OpenGLRenderer PROPERTIES LINK_FLAGS "-headerpad_max_install_names")
ELSEIF(UNIX)
    SET_TARGET_PROPERTIES(OpenGLRenderer PROPERTIES INSTALL_RPATH "$ORIGIN")
ENDIF()
    
# This library is part of the installation package.
INSTALL(TARGETS OpenGLRenderer EXPORT OVITO
	RUNTIME DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}"
	LIBRARY DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")

# Export target to make it accessible for external plugins.
IF(CMAKE_VERSION VERSION_LESS "3")
	EXPORT(TARGETS OpenGLRenderer NAMESPACE "Ovito::" APPEND FILE "${${PROJECT_NAME}_BINARY_DIR}/OVITOTargets.cmake")
ENDIF()

# Build corresponding GUI plugin.
IF(OVITO_BUILD_GUI)
	ADD_SUBDIRECTORY(gui)
ENDIF()

# Propagate list of plugins to parent scope.
SET(OVITO_PLUGIN_LIST ${OVITO_PLUGIN_LIST} PARENT_SCOPE)

=== examples/plugins/random_color/CMakeLists.txt ===
PROJECT(RandomColorPlugin)
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)

# Find OVITO build tree.
FIND_PACKAGE(OVITO REQUIRED)

# Generate plugin module.
OVITO_PLUGIN(RandomColorPlugin
	SOURCES RandomColorModifier.cpp
	PLUGIN_DEPENDENCIES Particles
)

=== src/3rdparty/botan/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Find system Botan library.
FIND_PACKAGE(Botan QUIET)

IF(BOTAN_FOUND)

	# Create imported target for the existing Botan library.
	ADD_LIBRARY(Botan SHARED IMPORTED GLOBAL)
	SET_PROPERTY(TARGET Botan PROPERTY IMPORTED_LOCATION "${Botan_LIBRARIES}")
	SET_PROPERTY(TARGET Botan APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${Botan_INCLUDE_DIRS}")

ELSE()

	# Build our own version of the Botan library.

	# Build library
	ADD_LIBRARY(Botan STATIC EXCLUDE_FROM_ALL botan/botan.cpp)

    # Link to Qt5.
    TARGET_LINK_LIBRARIES(Botan PRIVATE Qt5::Core)

	IF(APPLE)
		TARGET_COMPILE_DEFINITIONS(Botan PRIVATE
			BOTAN_TARGET_OS_IS_DARWIN 
			BOTAN_BUILD_COMPILER_IS_CLANG 
			BOTAN_TARGET_ARCH_IS_X86_64 
			BOTAN_HAS_MUTEX_PTHREAD
			BOTAN_TARGET_OS_IS_LINUX 
			BOTAN_TARGET_OS_HAS_DLOPEN 
			BOTAN_TARGET_OS_HAS_GMTIME_R 
			BOTAN_TARGET_OS_HAS_POSIX_MLOCK
			BOTAN_HAS_DYNAMICALLY_LOADED_ENGINE 
			BOTAN_HAS_DYNAMIC_LOADER
			BOTAN_TARGET_OS_HAS_GETTIMEOFDAY 
			BOTAN_HAS_ALLOC_MMAP
			BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM 
			BOTAN_HAS_ENTROPY_SRC_EGD 
			BOTAN_HAS_ENTROPY_SRC_FTW
			BOTAN_HAS_ENTROPY_SRC_UNIX 
			BOTAN_HAS_MUTEX_PTHREAD 
			BOTAN_HAS_PIPE_UNIXFD_IO
		)
	ELSEIF(UNIX)
		TARGET_COMPILE_DEFINITIONS(Botan PRIVATE
			BOTAN_TARGET_OS_HAS_GETTIMEOFDAY 
			BOTAN_HAS_ALLOC_MMAP
	    		BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM 
			BOTAN_HAS_ENTROPY_SRC_EGD 
			BOTAN_HAS_ENTROPY_SRC_FTW
			BOTAN_HAS_ENTROPY_SRC_UNIX 
			BOTAN_HAS_MUTEX_PTHREAD 
			BOTAN_HAS_PIPE_UNIXFD_IO
		)
	ELSEIF(WIN32)
		TARGET_COMPILE_DEFINITIONS(Botan PRIVATE
			BOTAN_TARGET_OS_IS_WINDOWS
			BOTAN_TARGET_OS_HAS_LOADLIBRARY 
			BOTAN_TARGET_OS_HAS_WIN32_GET_SYSTEMTIME
			BOTAN_TARGET_OS_HAS_WIN32_VIRTUAL_LOCK 
			BOTAN_HAS_DYNAMICALLY_LOADED_ENGINE
			BOTAN_HAS_DYNAMIC_LOADER 
			BOTAN_HAS_ENTROPY_SRC_CAPI 
			BOTAN_HAS_ENTROPY_SRC_WIN32
			BOTAN_HAS_MUTEX_WIN32
		)
		IF(MSVC)
			TARGET_COMPILE_DEFINITIONS(Botan PRIVATE BOTAN_BUILD_COMPILER_IS_MSVC BOTAN_TARGET_OS_HAS_GMTIME_S)
			TARGET_COMPILE_OPTIONS(Botan PRIVATE -wd4251 -wd4290 -wd4250)
		ENDIF()
	ELSE()
		MESSAGE(FATAL_ERROR "Building on this platform is not supported.")
	ENDIF()

	IF(CMAKE_COMPILER_IS_GNUCXX)
		TARGET_COMPILE_DEFINITIONS(Botan PRIVATE BOTAN_BUILD_COMPILER_IS_GCC)
	ENDIF()

	# Make header files of this library available to dependent targets.
	TARGET_INCLUDE_DIRECTORIES(Botan INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

ENDIF()

=== src/3rdparty/copr/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2016) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

SET(COPR_SOURCE_FILES
	index_copr.cpp
	coordination.cpp
	qcprot/qcprot.cpp
	qcprot/quat.cpp
)

# Build library.
ADD_LIBRARY(CombinatoriallyOptimalPointRegistration STATIC ${COPR_SOURCE_FILES})

# Link to Voro++ library.
TARGET_LINK_LIBRARIES(CombinatoriallyOptimalPointRegistration PRIVATE VoroPlusPlus)

# Make header files of this library available to dependent targets.
TARGET_INCLUDE_DIRECTORIES(CombinatoriallyOptimalPointRegistration INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/..")

# Since we will link this into the Particles plugin, we need to use the same setting for the fPIC flag.
SET_PROPERTY(TARGET CombinatoriallyOptimalPointRegistration PROPERTY POSITION_INDEPENDENT_CODE ON)

# Export this target.
INSTALL(TARGETS CombinatoriallyOptimalPointRegistration EXPORT OVITO 
    ARCHIVE DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}" 
    CONFIGURATIONS "")

=== src/3rdparty/geogram/CMakeLists.txt ===
# @brief Add sources from directories
# @details
# Add the sources from the specified \p directories to variable \p var
# and place them in the specified \p folder if non empty.
# @param[out] var name of the variable that receives the result list
# @param[in] folder the name of the folder
# @param[in] directories list of directories to scan
 
function(aux_source_directories var folder)
    set(sources)
    foreach(dir ${ARGN})
        file(GLOB _sources RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${dir}/*.[ch]" "${dir}/*.[ch]pp")
        list(APPEND sources ${_sources})
    endforeach() 
    
    if( NOT folder STREQUAL "")
        source_group(${folder} FILES ${sources})
    endif()

    set(${var} ${${var}} ${sources} PARENT_SCOPE)
endfunction()

aux_source_directories(SOURCES "Source Files"            .)
aux_source_directories(SOURCES "Source Files\\basic"     basic)
aux_source_directories(SOURCES "Source Files\\numerics"  numerics)
aux_source_directories(SOURCES "Source Files\\delaunay"  delaunay)
aux_source_directories(SOURCES "Source Files\\mesh"      mesh)
aux_source_directories(SOURCES "Source Files\\api"       api)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/..)
ADD_LIBRARY(geogram STATIC ${SOURCES})

# Make header files of this library available to dependent targets.
TARGET_INCLUDE_DIRECTORIES(geogram INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/..")
SET_PROPERTY(TARGET geogram PROPERTY POSITION_INDEPENDENT_CODE ON)

# Export this target.
INSTALL(TARGETS geogram EXPORT OVITO 
    ARCHIVE DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}" 
    CONFIGURATIONS "")

=== src/3rdparty/muparser/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Find muParser library.
FIND_PACKAGE(MuParser QUIET)

IF(MUPARSER_FOUND)

	# Create imported target for the existing muParser library.
	ADD_LIBRARY(muParser SHARED IMPORTED GLOBAL)
	SET_PROPERTY(TARGET muParser PROPERTY IMPORTED_LOCATION "${MuParser_LIBRARIES}")
	SET_PROPERTY(TARGET muParser APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${MuParser_INCLUDE_DIRS}")
	
ELSE()

	# Build our own version of the library.
	SET(MUPARSER_SOURCE_FILES
		muParser.cpp
		muParserBytecode.cpp
		muParserInt.cpp
		muParserTokenReader.cpp
		muParserError.cpp
		muParserCallback.cpp
		muParserBase.cpp
	)

	# Build library.
	ADD_LIBRARY(muParser STATIC ${MUPARSER_SOURCE_FILES})

	# Make header files of this library available to dependent targets.
	TARGET_INCLUDE_DIRECTORIES(muParser INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

    # Since we will link this into the Particles plugin, we need to use the same setting for the fPIC flag.
	SET_PROPERTY(TARGET muParser PROPERTY POSITION_INDEPENDENT_CODE ON)
	
	# Export this target.
	INSTALL(TARGETS muParser EXPORT OVITO 
	    ARCHIVE DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}" 
	    CONFIGURATIONS "")
    
ENDIF()

=== src/3rdparty/qssh/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Build library
ADD_LIBRARY(QSsh ${OVITO_DEFAULT_LIBRARY_TYPE}
	sftpchannel.cpp
	sftpdefs.cpp
	sftpincomingpacket.cpp
	sftpoperation.cpp
	sftpoutgoingpacket.cpp
	sftppacket.cpp
	sshcapabilities.cpp
	sshchannel.cpp
	sshchannelmanager.cpp
	sshconnection.cpp
	sshconnectionmanager.cpp
	sshcryptofacility.cpp
	sshincomingpacket.cpp
	sshkeyexchange.cpp
	sshkeygenerator.cpp
	sshkeypasswordretriever.cpp
	sshoutgoingpacket.cpp
	sshpacket.cpp
	sshpacketparser.cpp
	sshremoteprocess.cpp
	sshremoteprocessrunner.cpp
	sshsendfacility.cpp
	sshhostkeydatabase.cpp
	sshdirecttcpiptunnel.cpp
	sshinit.cpp
)

# Export symbols when building a Windows DLL.
TARGET_COMPILE_DEFINITIONS(QSsh PRIVATE QSSH_LIBRARY)

# Link to Botan library.
TARGET_LINK_LIBRARIES(QSsh PRIVATE Botan)

# Link to Qt5.
TARGET_LINK_LIBRARIES(QSsh PUBLIC Qt5::Core Qt5::Network)

# Make header files of this library available to dependent targets.
TARGET_INCLUDE_DIRECTORIES(QSsh PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")

# Make this library part of the installation package.
IF(OVITO_DEFAULT_LIBRARY_TYPE STREQUAL SHARED)
	INSTALL(TARGETS QSsh EXPORT OVITO
		RUNTIME DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}"
		LIBRARY DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")
ENDIF()

SET_TARGET_PROPERTIES(QSsh PROPERTIES MACOSX_RPATH TRUE)

# Export target to make it accessible for external plugins.
IF(CMAKE_VERSION VERSION_LESS "3")
	EXPORT(TARGETS QSsh NAMESPACE "Ovito::" FILE "${${PROJECT_NAME}_BINARY_DIR}/OVITOTargets.cmake")
ENDIF()

=== debian/changelog ===
ovito (2.9.0+dfsg1-5ubuntu2) bionic; urgency=medium

  * Fix build failure with recent qscintilla. See: #885644.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 07 Feb 2018 10:52:52 +0100

ovito (2.9.0+dfsg1-5ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Avoid FTBFS by building with -O2 on ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Nov 2017 09:05:46 +0100

ovito (2.9.0+dfsg1-5) unstable; urgency=medium

  * [680282d] Relax some unreliable tests to make the build reproducible.

 -- Anton Gladky <gladk@debian.org>  Mon, 20 Nov 2017 22:46:48 +0100

ovito (2.9.0+dfsg1-4) unstable; urgency=medium

  * [cf29859] Do not fail on test, if data-file does not exist.

 -- Anton Gladky <gladk@debian.org>  Mon, 20 Nov 2017 18:58:20 +0100

ovito (2.9.0+dfsg1-3ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Avoid FTBFS by building with -O2 on ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Nov 2017 08:28:37 +0100

ovito (2.9.0+dfsg1-3) unstable; urgency=medium

  [ Anton Gladky ]
  * Team upload.
  * [0ce9a9a] Apply Standards-Version: 4.1.1
  * [6dabeb5] Remove myself from uploaders
  * [3e02bb4] Remove unneeded testsuite-field in d/control

  [ Gilles Filippini ]
  * [35bf4bd] Force using default Python 3 interpreter. (Closes: #878818)

 -- Anton Gladky <gladk@debian.org>  Sat, 18 Nov 2017 21:20:59 +0100

ovito (2.9.0+dfsg1-2ubuntu2) bionic; urgency=medium

  * Rebuild against new libnetcdf13.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Oct 2017 13:34:38 +0200

ovito (2.9.0+dfsg1-2ubuntu1) artful; urgency=low

  * Merge from Debian Sid. Remaining changes:
    - Avoid FTBFS by building with -O2 on ppc64el.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 17 Aug 2017 00:02:03 -0500

ovito (2.9.0+dfsg1-2) unstable; urgency=medium

  * [cdb5bde] Fix FTBFS on archs, where char is unsigned. (Closes: #871248)

 -- Anton Gladky <gladk@debian.org>  Thu, 10 Aug 2017 19:44:59 +0200

ovito (2.9.0+dfsg1-1) unstable; urgency=medium

  * [7aa098e] Add missing dependency
  * [7aedcd1] Refresh patches, remove old ones.
  * [9629741] Disable avi-test.
  * [4cfa51d] Fix compilation with GCC 7. (Closes: #853603)
  * [527f425] Merge two patches.
  * [b48353b] New upstream version 2.9.0+dfsg1
  * [194099f] Bump Standards-Version: 4.0.0

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Aug 2017 23:51:38 +0200

ovito (2.8.1+dfsg2-5ubuntu2) artful; urgency=medium

  * No-change rebuild against python3.6

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 28 Jul 2017 23:10:06 -0400

ovito (2.8.1+dfsg2-5ubuntu1) zesty; urgency=medium

  * Avoid FTBFS by building with -O2 on ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Apr 2017 12:01:43 +0200

=== debian/control ===
Source: ovito
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               docbook-xml,
               docbook-xsl,
               docbook-xsl-doc-html,
               libavcodec-dev,
               libavdevice-dev,
               libfftw3-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-python-dev,
               libbotan1.10-dev,
               libcgal-qt5-dev [!armel],
               libglu1-mesa-dev [armel armhf],
               libgl1-mesa-dev [armel armhf],
               libgsl0-dev,
               libhdf5-dev,
               libmuparser-dev,
               libnetcdf-dev,
               libqscintilla2-qt5-dev,
               libqt5opengl5-dev,
               libqcustomplot-dev,
               libqwt-qt5-dev,
               libswscale-dev,
               povray,
               pybind11-dev,
               python-dev,
               python3-sphinx,
               python3-matplotlib,
               python3-sip,
               python3-numpy,
               python3-pyqt5,
               qtbase5-dev-tools,
               qtscript5-dev,
               xsltproc,
               zlib1g-dev
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ovito.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ovito.git
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any
Depends: python,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ovito-doc
Suggests: povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: ovito
Provides: ovito-examples
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(DEB_HOST_ARCH), ppc64el)
export DEB_CXXFLAGS_MAINT_STRIP = -O3
export DEB_CXXFLAGS_MAINT_APPEND = -O2
endif

export QT_SELECT=qt5
%:
	dh $@ --parallel

extra_flags += \
	-DPYTHON_EXECUTABLE=/usr/bin/python3 \
	-DOVITO_BUILD_DOCUMENTATION=TRUE \
	-DOVITO_BUILD_PLUGIN_SCRIPTING=TRUE \
	-DOVITO_BUILD_PLUGIN_NETCDF=TRUE \
	-DOVITO_VIDEO_OUTPUT_SUPPORT=ON \
	-DOVITO_USE_SYSTEM_QCUSTOMPLOT=ON \
	-DOVITO_BUILD_PLUGIN_TACHYON=ON

ifeq (,$(filter $(DEB_HOST_ARCH), armel s390x ppc64el arm64))
	extra_flags += -DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=TRUE
else
	extra_flags += -DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=FALSE
endif

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_install-arch:
	dh_install -a --list-missing
	find ./debian/ovito -type d -empty -delete
	find ./ -name "*DS_Store" | xargs rm -f
	find . -name '__pycache__' -print0 | xargs -0 rm -rf
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_install-indep:
	dh_install -i
	dh_sphinxdoc

ifneq (,$(filter $(DEB_HOST_ARCH), armel s390x mips mips64el))
override_dh_auto_test:
	dh_auto_test || true
endif

=== debian/tests/control ===
Tests: ovitotest
Depends: ovito

=== debian/watch ===
version=3
opts=repack,compression=xz,repacksuffix=+dfsg2,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,\
filenamemangle=s/.*\.tar\.gz\?ref=v?(\d\S+)/ovito-$1\.tar\.gz/g \
https://gitlab.com/stuko/ovito/tags?sort=updated_desc .*archive\.tar\.gz\?ref=v?(\d\S+)
